import { MapSet, Token, SymbolType, IContainer, InjectToken, LoadType } from '@ts-ioc/core';
/**
 * container pool
 *
 * @export
 * @class ContainerPool
 */
export declare class ContainerPool {
    protected globalModules: LoadType[];
    protected pools: MapSet<Token<any>, IContainer>;
    constructor();
    getTokenKey(token: Token<any>): SymbolType<any>;
    /**
     * use global modules.
     *
     * @param {...LoadType[]} modules
     * @returns {this}
     * @memberof ContainerPool
     */
    use(...modules: LoadType[]): this;
    private inited;
    hasInit(): boolean;
    initDefault(): Promise<IContainer>;
    isDefault(container: IContainer): boolean;
    hasDefault(): boolean;
    defaults: IContainer;
    setDefault(container: IContainer): void;
    getDefault(): IContainer;
    set(token: Token<any>, container: IContainer): void;
    get(token: Token<any>): IContainer;
    has(token: Token<any>): boolean;
    static classAnnations: any;
}
export declare const ContainerPoolToken: InjectToken<ContainerPool>;
/**
 *  global container pools.
 */
export declare const containerPools: ContainerPool;
